% Constructor of the base class.
% Always takes either zero or one argument.  For no arguments, the default
% object is created.  For one argument, the argument may be either an
% object of the same type, in which case the copy is created; or, it may be
% a struct with the following fields representing options.
% Options: none
%
function retobj = classbase (varargin)
    class_name='classbase';
    if (nargin == 0)
        self. Something = 0;% must have a field: no field causes Matlab crash
        self = class(self, class_name);
        retobj = self;
        return;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            error(['Illegal argument ' inputname(1) ' of class ' class(varargin{1}) '!']);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
