% Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'id'}, {'node identifier, positive integer'}};
            {{'xyz'}, {'coordinates of the node, array [dim,1], where dim = dimension of the embedding space'}};
            {{'xyz3'}, {'coordinates of the node, array [3,1]'}}};
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'id'
                val = self.id;
            case 'xyz'
                val = self.xyz;
            case 'xyz3'
                if (length(self.xyz)==1)
                    val = [self.xyz 0 0];
                elseif (length(self.xyz)==2)
                    val = [self.xyz 0];
                else
                    val = self.xyz;
                end
            otherwise
                error(['Unknown property ''' prop_name '''!']);
        end
    end
end
