% Number the equations.
%    Call as:
%      f=numbereqns(f);
% Note that we're assigning to f: f changes inside this function!
%
% The free components in the field are numbered consecutively.
% No effort is made to optimize the numbering in any way.
%
function retobj = numbereqns (self,varargin)
    invalid_eqnum = get(sysmat, 'invalid_eqnum');
    [nfens,dim] = size(self.values);
    if nargin > 1
        self.neqns = varargin{1};
    else
        self.neqns = 0;
    end
    for i=1:nfens
        for j=1:dim
            if (~self.is_prescribed(i,j))
                self.neqns = self.neqns + 1;
                self.eqnums(i,j) = self.neqns;
            else
                self.eqnums(i,j) = invalid_eqnum;
            end
        end
    end
    retobj = self;
end


