% Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'dim'}, {'topological dimension (2=surface)'}};
            {{'thickness'}, {'thickness of the element, double or function handle'}};
            };
        val = cat(1, get(self.gcell), val);
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'dim'
                val = 2; % two-dimensional
            case 'thickness'
                val = self.thickness;
            otherwise
                val = get(self.gcell, prop_name);
        end
    end
end
