% Update material state.  Return the updated material state, and the
% requested quantity (default is the stress). 
%   Call as:
%     [out,newms] = update(m, ms, context)
%  where
%     m=material
%     ms = material state
%     context=structure
%        with mandatory fields that depend on the particular material
%        and optional fields
%           output=type of quantity to output, and interpreted by the
%           particular material; [] is returned when the material does not
%           recognize the requested quantity to indicate uninitialized
%           value.  It can be tested with isempty ().
%              output ='Cauchy' - Cauchy stress; this is the default 
%                      when output type is not specified.  
%              output ='2ndPK' - 2nd Piola-Kirchhoff stress; 
%           It is assumed that stress is output in vector form.
%   The output arguments are
%     out=requested quantity
%     newms=new material state; don't forget that if the update is final
%           the material state newms must be assigned and stored.  Otherwise
%           the material update is lost!
%
function [stress, newmatstate] = update (self, context)
error('Base class does not implement this behaviour!');
return;

