function ri=get_rotint(keyw)
keyws{1}={'1' 'nms' 'nms_cd'};
keyws{2}={'2' 'nmb' 'nmb_cd'};
keyws{3}={'3' 'nmb_wro' 'nmb_wro_cd'};
keyws{4}={'4' 'lewis_simo' 'ls'};
keyws{5}={'5' 'mid_lie_expl_2'};
keyws{6}={'6' 'euler_lie' 'lieeul'};
keyws{7}={'7' 'nmbv' 'nmbv_cd'};
keyws{9}={'9' 'akw'};
keyws{10}={'10' 'inmb'};
keyws{13}={'13' 'emc'};
keyws{44}={'44' 'lewis_simo_nonsympl' 'ls_nonsympl'};
keyws{55}={'55' 'imid_lie' 'liemid' 'midlie' 'mid_lie_expl'};
keyws{56}={'56' 'imid'};
keyws{61}={'61' 'nmmec1'};
keyws{100}={'0' '100' 'simo_wong'};
keyws{101}={'101' 'simo_wong_algo_c2'};
keyws{102}={'102' 'simo_wong_algo_c1'};
keyws{113}={'113' 'simo_wong_algo_c2_emc'};
keyws{133}={'nmmec'};
keyws{134}={'hulb_stagg'};
keyws{136}={'136' 'emc_var'};
keyws{361}={'361' 'mid_lie_impl'};
keyws{505}={'505' 'mid_lie_expl_1'};
keyws{506}={'506' 'mid_lie_expl_3'};
keyws{507}={'507' 'mid_lie_expl_4'};
keyws{508}={'508' 'mid_lie_expl_5'};
keyws{509}={'509' 'mid_lie_expl_ea'};
keyws{610}={'613' 'nmmec2'};
keyws{611}={'611' 'nmmec3'};
keyws{990}={'990' 'cardona_geradin'};
keyws{998}={'998' 'trapez_int'};
keyws{999}={'999' 'trapez'};
keyws{1000}={'0' '1000' 'simo_cd'};

if (nargin == 0)
    disp('Here is the list of integrators:');
    for i=1:length(keyws)
        if (~isempty(keyws{i}))
            disp(keyws{i});
        end
    end
    return;
end

if (strcmp(class(keyw),'double'))
    keyw=num2str(keyw);
end
if (strcmp(class(keyw),'cell'))
    keyw=keyw{1};
end
if (~strcmp(class(keyw),'char'))
    keyw=num2str(keyw);
end

switch (keyw)
    case keyws{1}
        ri=rotint_nms_cd;
    case keyws{2}
        ri=rotint_nmb_cd;
    case keyws{3}
        ri=rotint_nmb_wro_cd;
    case keyws{4}
        ri=rotint_lewis_simo;
    case keyws{44}
        ri=rotint_lewis_simo_nonsympl;
    case keyws{5}
        ri=rotint_mid_lie_expl_2;
    case keyws{505}
        ri=rotint_mid_lie_expl_1;
    case keyws{506}
        ri=rotint_mid_lie_expl_3;
    case keyws{507}
        ri=rotint_mid_lie_expl_4;
    case keyws{508}
        ri=rotint_mid_lie_expl_5;
    case keyws{509}
        ri=rotint_mid_lie_expl_ea;
    case keyws{55}
        ri=rotint_mid_lie_expl;
    case keyws{131}
        ri=rotint_mid_lie_expl_1;
    case keyws{361}
        ri=rotint_mid_lie_impl;
    case keyws{6}
        ri=rotint_euler_lie;
    case keyws{7}
        ri=rotint_nmbv_cd;
    case keyws{9}
        ri=rotint_akw_mid;
    case keyws{10}
        ri=rotint_inmb;
    case keyws{13}
        ri=rotint_emc;
    case keyws{136}
        ri=rotint_emc_var;
    case keyws{133}
        ri=rotint_nmmec;
    case keyws{134}
        ri=rotint_hulb_stagg;
    case keyws{61}
        ri=rotint_nmmec1;
    case keyws{613}
        ri=rotint_nmmec2;
    case keyws{611}
        ri=rotint_nmmec3;
    case keyws{1000}
        ri=rotint_simo_cd;
    case keyws{100}
        ri=rotint_simo_wong;
    case keyws{101}
        ri=rotint_simo_wong_algo_c2;
    case keyws{102}
        ri=rotint_simo_wong_algo_c1;
    case keyws{113}
        ri=rotint_simo_wong_algo_c2_emc;
    case keyws{990}
        ri=rotint_cardona_geradin;
    case keyws{999}
        ri=rotint_trapez;
    case keyws{998}
        ri=rotint_trapez_int;
    case keyws{56}
        ri=rotint_imid;
    otherwise
        error('Unknown integrator type');
end
